//
// Created by nicolas on 23/03/18.
//

#ifndef ESC_ARRAY_H
#define ESC_ARRAY_H

#include <stddef.h>

typedef struct st_array {
    size_t size;
    void** data;
} array_t;

typedef void (*array_deallocator)(void*);

array_t* array_create(size_t n, ...);
void array_destroy(array_t* array, array_deallocator destroyer);

#endif //ESC_ARRAY_H
