//
// Created by nicolas on 20/03/18.
//

#ifndef ESC_QUEUE_H
#define ESC_QUEUE_H

#include "bool.h"

typedef struct st_queue queue_t;

queue_t* queue_create();
void queue_destroy(queue_t* q);
void queue_enqueue(queue_t* q, void* item);
void* queue_dequeue(queue_t* q);
void* queue_peek(queue_t* q);
size_t queue_size(queue_t* q);

typedef bool_t (*find_predicate)(void* item, void* arg);
void* queue_remove(queue_t* q, find_predicate, void* arg);

#endif //ESC_QUEUE_H
